<?php
class WCAM_OrderDetailsAddon
{
	public function __construct()
	{
			add_action( 'init', array( &$this, 'init' ) );
	
	}
	public function init()
	{
		$wcam_option_model = new WCAM_Option();
		$position = $wcam_option_model->get_option( 'order_details_page_attachment_position', 'woocommerce_order_details_after_order_table');
		add_action( $position, array( &$this, 'front_end_order_page_addon' ), 99 ); //99: in this way the attachments are putted after the 'woocommerce_order_again_button' action
	}
	private function saveCustomerFeedbacks($order_id, $file_order_metadata)
	{
		global $wcam_order_model;
		/* echo "<pre>";
		var_dump($_REQUEST);
		echo "<pre>";  */
		$email_string = "";
		
		$wcam_option_model = new WCAM_Option();
		$wpml = new WCAM_Wpml();
		$curr_lang = $wpml->get_current_language();
		$options = $wcam_option_model->get_option();
		$order = wc_get_order($order_id);
		$feedback_has_been_saved = array();
		
		$approve_not_yet_text = isset($options['approve_not_yet_text']) && isset($options['approve_not_yet_text'][$curr_lang]) ? $options['approve_not_yet_text'][$curr_lang] : __('Not yet', 'woocommerce-attach-me');
		$approve_yes_text = isset($options['approve_yes_text']) && isset($options['approve_yes_text'][$curr_lang]) ? $options['approve_yes_text'][$curr_lang] : __('Yes', 'woocommerce-attach-me');
		$approve_no_text = isset($options['approve_no_text']) && isset($options['approve_no_text'][$curr_lang]) ? $options['approve_no_text'][$curr_lang] : __('No', 'woocommerce-attach-me');
		$email_approve_box_title = isset($options['email_approve_box_title']) && isset($options['email_approve_box_title'][$curr_lang]) ? $options['email_approve_box_title'][$curr_lang] : __('Customer has approved?', 'woocommerce-attach-me');
		$email_feedback_box_title = isset($options['email_feedback_box_title']) && isset($options['email_feedback_box_title'][$curr_lang]) ? $options['email_feedback_box_title'][$curr_lang] : __('Customer feedback', 'woocommerce-attach-me');
		$email_no_customer_feedback_message = isset($options['email_no_customer_feedback_message']) && isset($options['email_no_customer_feedback_message'][$curr_lang]) ? $options['email_no_customer_feedback_message'][$curr_lang] : __('No customer feedback', 'woocommerce-attach-me');
		$status_to_assign_for_approval = isset($options['status_to_assign_for_approval']) ? $options['status_to_assign_for_approval'] : 'unchanged';
		$status_to_assign_for_not_approval = isset($options['status_to_assign_for_not_approval']) ? $options['status_to_assign_for_not_approval'] : 'unchanged';
		$status_to_assign_for_waiting_for_approval = isset($options['status_to_assign_for_waiting_for_approval']) ? $options['status_to_assign_for_waiting_for_approval'] : 'unchanged';
		$save_feedback_as_order_note = wcam_get_value_if_set($options, 'feedback_text_save_on_order_note' , 'no') == 'yes';
			
		//wcam_var_dump($_REQUEST);
		foreach($_REQUEST['wcam_attachment_id'] as $key => $file_id)
		{
			
			if(isset($_REQUEST['wcam_customer_approval']) && isset($_REQUEST['wcam_customer_approval'][$file_id])) //accepts even GET parameters
			{
				$feedback_has_been_saved[$file_id] = true;
				$file_order_metadata[$file_id]['customer-has-approved'] = $_REQUEST['wcam_customer_approval'][$file_id];
			}
			if(isset($_REQUEST['wcam_customer_feedback']) &&  isset($_REQUEST['wcam_customer_feedback'][$file_id]))
			{
				$new_feedback_text = stripslashes($_REQUEST['wcam_customer_feedback'][$file_id]);
				//Save feedback on order note (if changed)
				if($save_feedback_as_order_note &&  wcam_get_value_if_set($file_order_metadata, array($file_id, 'customer-feedback') , '') != $new_feedback_text)
				{
					$order->add_order_note(sprintf(__("<p>Attach Me! - Feedback text for: %s </p><p>%s</p>", 'woocommerce-attach-me'), $file_order_metadata[$file_id]['title'], $new_feedback_text));
				}
			
				$feedback_has_been_saved[$file_id] = true;
				$file_order_metadata[$file_id]['customer-feedback'] = $new_feedback_text;
			}
			
			//Email
			if($file_order_metadata[$file_id]['customer-admin-notification'] == 'yes')
			{
				$email_string .= '<h3>'.$file_order_metadata[$file_id]['title'].'</h3>';
				$approve_text;
				if(isset($file_order_metadata[$file_id]['customer-has-approved']))
				{
					switch($file_order_metadata[$file_id]['customer-has-approved'])
					{
						case "none": $approve_text = $approve_not_yet_text; break;
						case "yes": $approve_text = $approve_yes_text;break;
						case "no": $approve_text = $approve_no_text;break;
					}
					$email_string .=  '<strong>'.$email_approve_box_title.'</strong><br/>';
					$email_string .=  $approve_text.'<br/>';
				}
				//Feedback
				if(isset($file_order_metadata[$file_id]['customer-feedback']) && !empty($file_order_metadata[$file_id]['customer-feedback']))
				{
					$email_string .=  '<strong>'.$email_feedback_box_title.'</strong><br/>';
					$email_string .=  $file_order_metadata[$file_id]['customer-feedback'].'<br/>';
				}
				else
					$email_string .=  '<strong>'.$email_no_customer_feedback_message.'</strong><br/>';
			}
			
			//Status change
			if(isset($file_order_metadata[$file_id]['customer-has-to-be-approved']) && $file_order_metadata[$file_id]['customer-has-to-be-approved'] == 'yes' && isset($_REQUEST['wcam_customer_approval'][$file_id]))
			 {
				  switch($_REQUEST['wcam_customer_approval'][$file_id]) //accepts even get parameters
				 {
					 case 'yes': if($status_to_assign_for_approval != 'unchanged') {$order->update_status(str_replace ("wc-", "", $status_to_assign_for_approval)); $order->save();};
					 break;
					 case 'no':  if($status_to_assign_for_not_approval != 'unchanged') {$order->update_status(str_replace ("wc-", "", $status_to_assign_for_not_approval)); $order->save();}
					 break;
					 case 'none':  if($status_to_assign_for_waiting_for_approval != 'unchanged') {$order->update_status(str_replace ("wc-", "", $status_to_assign_for_waiting_for_approval)); $order->save();}
					 break;
				 }
			 }
		}
		
		if($email_string != "")
		{
			$admin_notification_recipients = isset($options['admin_notification_recipients']) && $options['admin_notification_recipients'] != "" ? $options['admin_notification_recipients'] : get_option('woocommerce_email_from_address'); //get_option('admin_email')
			
			$email_sender = new WCAM_Email();
			$email_sender->trigger($admin_notification_recipients, __('New Approval(s)/Feedback(s) for order: ', 'woocommerce-attach-me').$order_id, $email_string );
		}
		
		
		//update_post_meta( $order_id, '_wcam_attachments_meta', $file_order_metadata);
		$wcam_order_model->update_meta( $order_id, '_wcam_attachments_meta', $file_order_metadata);
		return array('order_meta'=> $file_order_metadata, 'feedback_has_been_saved' => $feedback_has_been_saved);
	}
	public function front_end_order_page_addon( $order )
	{
		$options = new WCAM_Option();
		$all_options = $options->get_option();
		
		if($options->get_option('hide_attachments_in_thank_you_page', false) != false &&  did_action('woocommerce_thankyou') > 0 )
			return;
		
		global $wcam_product_model,  $wcam_order_model;
		$default_width = get_option('thumbnail' . '_size_w' );
		$default_height = get_option('thumbnail' . '_size_h' );
		$feedback_has_been_saved = array();
		$wpml = new WCAM_Wpml();
		$curr_lang = $wpml->get_current_language();
		$order_id = WCAM_Order::get_id($order) ;	
		//$file_order_metadata = get_post_meta($order_id, '_wcam_attachments_meta'); //can be removed and used the WCAM_Option
		//$file_order_metadata = !$file_order_metadata ? array():$file_order_metadata[0];
		$file_order_metadata = $wcam_order_model->get_attachments_metadata($order_id, array());
		
		$preview_image = $options->get_option('dispaly_image_preview', 'no');
		$use_lightbox_preview = $options->get_option('use_lightbox_preview', false);
		$select_box_style = $options->get_option('approval_box_style', 'select');
		$preview_image_height = $options->get_option('thumb_height', $default_height);
		$preview_image_width = $options->get_option('thumb_width', $default_width);	
		$order_attachment_container = $options->get_option('order_attachment_container', 320);	
		$no_attachments_message = isset($all_options['no_attachments_message']) && isset($all_options['no_attachments_message'][$curr_lang]) ? $all_options['no_attachments_message'][$curr_lang] : "";
		//$time_format= $options->get_option('exiring_date_time_format', 'd/m/Y');
		$link_open_method =  (bool)$options->get_option('open_link_in_same_window', false) ? '_self' : '_blank';
		$exists_at_least_one_attachment_to_show = 0;
		$download_view_button_text = isset($all_options['download_view_button_text']) && isset($all_options['download_view_button_text'][$curr_lang]) ? $all_options['download_view_button_text'][$curr_lang] : __('Download / View', 'woocommerce-attach-me');
			
		if(isset($_REQUEST) && isset($_REQUEST['wcam_save_customer_feedbacks']))
		{
			$save_data_result = $this->saveCustomerFeedbacks($order_id, $file_order_metadata );
			$file_order_metadata = $save_data_result['order_meta'];
			$feedback_has_been_saved = $save_data_result['feedback_has_been_saved'];
		}
		
		if($preview_image && $use_lightbox_preview)
		{
			wp_enqueue_script( 'wcam-lightbox', wcam_PLUGIN_PATH . '/js/lightbox.js', array( 'jquery' ));
			wp_enqueue_style( 'wcam-lightbox', wcam_PLUGIN_PATH. '/css/lightbox.css' );
		}
		wp_enqueue_style( 'css-wcam_frontend', wcam_PLUGIN_PATH . '/css/wcam-frontend.css' );
		wp_register_script('wcam-frontend-order-details',  wcam_PLUGIN_PATH . '/js/wcam-frontend-order-details.js', array( 'jquery' ));
		$js_params = array(
				'wc_ver' => WC_VERSION,
				'ajax_url' => admin_url('admin-ajax.php'),
				);
		wp_localize_script( 'wcam-frontend-order-details', 'wcam', $js_params );
		wp_enqueue_script( 'wcam-frontend-order-details' );
		if(!empty($file_order_metadata))
		{
			//Texts and Miltilanguages
			$title = isset($all_options['title_box']) && isset($all_options['title_box'][$curr_lang]) ? $all_options['title_box'][$curr_lang] : __('Attachments', 'woocommerce-attach-me');			
			$approve_box_title = isset($all_options['approve_box_title']) && isset($all_options['approve_box_title'][$curr_lang]) ? $all_options['approve_box_title'][$curr_lang] : __('Do you approve?', 'woocommerce-attach-me');
			$approve_already_sent_message = isset($all_options['approve_already_sent_message']) && isset($all_options['approve_already_sent_message'][$curr_lang]) ? $all_options['approve_already_sent_message'][$curr_lang] : __('Approvation already sent. Selected value was:', 'woocommerce-attach-me');
			$approve_not_yet_text = isset($all_options['approve_not_yet_text']) && isset($all_options['approve_not_yet_text'][$curr_lang]) ? $all_options['approve_not_yet_text'][$curr_lang] : __('Not yet', 'woocommerce-attach-me');
			$approve_yes_text = isset($all_options['approve_yes_text']) && isset($all_options['approve_yes_text'][$curr_lang]) ? $all_options['approve_yes_text'][$curr_lang] : __('Yes', 'woocommerce-attach-me');
			$approve_no_text = isset($all_options['approve_no_text']) && isset($all_options['approve_no_text'][$curr_lang]) ? $all_options['approve_no_text'][$curr_lang] : __('No', 'woocommerce-attach-me');
			$feedback_box_title = isset($all_options['feedback_box_title']) && isset($all_options['feedback_box_title'][$curr_lang]) ? $all_options['feedback_box_title'][$curr_lang] : __('Please enter a feedback', 'woocommerce-attach-me');
			$disclaimer_text = isset($all_options['disclaimer_text']) && isset($all_options['disclaimer_text'][$curr_lang]) ? $all_options['disclaimer_text'][$curr_lang] : "";
			$copy_to_clipboard_button_text = isset($all_options['copy_to_clipboard_button_text']) && isset($all_options['copy_to_clipboard_button_text'][$curr_lang]) ? $all_options['copy_to_clipboard_button_text'][$curr_lang] : __('Copy file URL to clipboard', 'woocommerce-attach-me');
			$exists_at_least_one_attachment_to_show = $wcam_order_model->number_of_visible_attachments($order);
			
			if(file_exists ( get_template_directory()."/wcam/view_order_template.php" ))
				include get_template_directory()."/wcam/view_order_template.php";
			else
				include WCAM_PLUGIN_ABS_PATH.'/templates/view_order_template.php';
		}
		
		//Texts and Miltilanguages
		$product_attachments_box_title = isset($all_options['product_attachments_box']) && isset($all_options['product_attachments_box'][$curr_lang]) ? $all_options['product_attachments_box'][$curr_lang] : __('Downloads', 'woocommerce-attach-me');
		$products_data = $wcam_product_model->get_attachments_downloadable_in_order_details_page($order);
		if(file_exists ( get_template_directory()."/wcam/view_order_template_products_attachments.php" ))
			include get_template_directory()."/wcam/view_order_template_products_attachments.php";
		else
			include WCAM_PLUGIN_ABS_PATH.'/templates/view_order_template_products_attachments.php';
		
		//No attachments ($products_data is in view_order_template_products_attachments template)
		if((!isset($file_order_metadata) || empty($file_order_metadata) || $exists_at_least_one_attachment_to_show == 0 ) && empty($products_data) && $no_attachments_message!="")
				echo "<h4 id='wcam-no-attachments-message'>".$no_attachments_message."</h4>";
					
	}
}
?>